/*
* BDMult.java -- ¿Ĺ¿
* @version $Revision: 1.8 $, $Date: 2003/03/24 03:37:58 $
* BDTools.java  BITools.java ȤäƤ롣
*/

import java.math.*;

public class BDMult {
    /**
    *BigDecimal a, b Ѥ̥ӥåȤȲ̥ӥåȤʬƷ׻ޤ
    *ƱΤξ軻פΤŪˤ3/4η׻̤ǺѤߤޤ<br>
    * 10ʤǤηĹޤޤǤڤΤƤˤ <code>{@link BDTools#roundOff}</code>
    * Ѥޤ뤤ϡ{@link BDTools#precision} ˽ϷꤷBDToolsνϴؿƤӽФ
    *ưŪڤΤƤޤ<br>
    *2 ʤǷ׻Ƥ뤿ᡤȤС1.0*10<sup>1000</sup> * 1.0*10<sup>-500</sup> 
    *Τ 1.0*10<sup>500</sup> ˤϤʤޤ
    *@see BDTools
    *@see BITools
    */
    public static BigDecimal bdMult(final BigDecimal a, final BigDecimal b, int precision) {
        if (a.signum() == 0 || b.signum() == 0) return BDTools.ZERO;
        // ͭΥӥåȿ
        int bp = (int)(precision * Math.log(10) / Math.log(2)) + 1;
        BigInteger m = a.unscaledValue(), n = b.unscaledValue(), r;
        int u = bp / 2;
        int scale = a.scale() + b.scale();
        int fm = m.bitLength(), fn = n.bitLength();

        if (fm <= u && fn <= u) { // ûƱ
            r = BITools.biMult(m, n);
            return new BigDecimal(r, scale);
        }
        if (fm < fn) return bdMult(b, a, precision); // Ƶ, a Υӥåȿ>=bΥӥåȿˤ
        if (m.signum() < 0) m = m.negate();
        if (n.signum() < 0) n = n.negate();
        int shift = 0;
        // ̤פʥӥåȤڤΤƤ롣aޤb᤿ٰʾηľɬס
        if (fm > bp) {
            m  = m.shiftRight(fm - bp);  shift += fm - bp;
            fm = m.bitLength();
        }
        if (fn > bp) {
            n  = n.shiftRight(fn - bp);  shift += fn - bp;
            fn = n.bitLength();
        }
        // Ǥϡfm >= fn, fm > u
        // mn򡤾uӥåȡ̤ĤΥӥåȤʬ롣
        if (fn <= u) { // Ĺû, fm > u Ƚפʤ
            r = BITools.biMult(m, n);
        } else { // ĹƱΤ
            BigInteger pm = BigInteger.ONE.shiftLeft(fm - u); // pm = 1 << (fm - u);
            pm = pm.subtract(BigInteger.ONE);                 // pm -= 1; pm = 0xfff...f
            BigInteger mL = m.and(pm), mH = m.subtract(mL);
            if (a.equals(b)) { // 2ξ
                r = BITools.biMult(mH, mH);
                BigInteger lh = BITools.biMult(mL, mH);
                r = r.add(lh.shiftLeft(1)); // r <-- mH^2 + 2 * mL * mH
            } else { // a != b
            // m = mH + mL, n = nH + nL ηˤ롣
                BigInteger pn = BigInteger.ONE.shiftLeft(fn - u); // pn = 1 << (fn - u);
                pn = pn.subtract(BigInteger.ONE);                 // pn -= 1; pn = 0xfff...f
                BigInteger nL = n.and(pn), nH = n.subtract(nL);
            // ̤¿ΥӥåȤ0ǤäƤBITools.biMult()롣
                r = BITools.biMult(mH, nH);
                r = r.add(BITools.biMult(mL, nH));
                r = r.add(BITools.biMult(mH, nL));
            }
        }
        // פʲ̥ӥåȤ0ˤ롣
        int sr = r.bitLength() - bp;
        if (sr > 0) { r = r.shiftRight(sr);  r = r.shiftLeft(sr); } // ڤΤ
        if (shift != 0) r = r.shiftLeft(shift);  // ɬɬסȤޤȤΤԲġ
        if (a.signum() * b.signum() < 0) r = r.negate();
        return new BigDecimal(r, scale); // 10ʤǤηĹ2ʤǤbpӥå١
    }
}
