/*
* BDTools.java -- BigDecimal ƻ
* @version $Revision: 1.15 $, $Date: 2003/03/26 14:35:33 $
* ʸˤϽϴطʤɤϺܤ
*/
import java.math.*;
import java.util.*;
import java.io.*;

/**
*BigDecimal ξƻ񽸤󶡤ޤ
* @see BDtoE_Form
*/
public class BDTools {
    /**
    *10 ʤǤνϷݻƤޤ
    */
    public static int decNumber;
    /**
    *10 ʤǤνϷǤޤʤϤȤprecision + 1 ܤͼθޤ
    */
    public static int precision = -1;
    /**
    * {@link #getExp10}ƤФ줿ȤβݻƤޤ
    */
    public static double mant;
    /**
    *BigDecimal  0.0 Ǥ
    */
    public static final BigDecimal ZERO = new BigDecimal(0.0);
    /**
    *BigDecimal  1.0 Ǥ
    */
    public static final BigDecimal ONE  = new BigDecimal(1.0);
    /**
    *BigDecimal  10.0 Ǥ
    */
    public static final BigDecimal TEN = new BigDecimal(10.0);
    private static long seed = System.currentTimeMillis();
    /**
    * dec  1.0 꾮֤ޤ
    */
    public static BigDecimal random(int dec) {
        int bits = (int)(dec * Math.log(10.0) / Math.log(2.0));
        Random     rnd  = new Random(seed++);
        BigInteger mant = new BigInteger(bits, rnd);
        BigDecimal bd   = new BigDecimal(mant, biFig10(mant));

        while (bd.compareTo(ONE) > 0) bd = bd.movePointLeft(1); // ޤˤ¹Ԥʤ
        return bd;
    }
    /**
    * ̤ 0 Ǥʤӥåȿ֤ޤ<br>
    * <b></b><code> 1100 0101 1010 0000 0000</code> Ǥ 11 ֤ޤ
    */
    public static int nonZeroBitLength(BigDecimal x) {
        BigInteger u = x.unscaledValue();
        return u.bitLength() - u.getLowestSetBit();
    }
    /**
    * ξ(place + 1)̤Ǵݤޤ
    */
    public static BigDecimal roundOff(BigDecimal x, int place, int roundingMode) {
        int e = getExp10(x);

        x = x.movePointLeft(e);
        x = x.divide(ONE, place, roundingMode);  // 1 ǳäƤ롣
        return x.movePointRight(e);
    }
    /**
    * (place + 1)̤ǻͼθޤ
    */
    public static BigDecimal roundOff(BigDecimal x, int place) {
        return roundOff(x, place, BigDecimal.ROUND_HALF_UP);
    }
    /**
    * (place + 1)̰ʲڤΤƤޤ
    */
    public static BigDecimal roundDown(BigDecimal x, int place) {
        return roundOff(x, place, BigDecimal.ROUND_DOWN);
    }
    /**
    * BigInteger r  10 ɽǤηγͤޤ
    */
    public static int biFig10(BigInteger r) {
        return (int)(r.bitLength() * Math.log(2) / Math.log(10)) + 1;
    }
    /**
    * BigDecimal x  10 ɽǤͭγͤޤ̤ 0 ޤߤޤ
    */
    public static int bdEffFig10(BigDecimal x) {
        return biFig10(x.unscaledValue());
    }
    private static final int DOUBLE_PREC = 15; // double ͭ
    /**
    * BigDecimal x  double m (1.0|m|10.0)Ѥ<b>m10<sup>e</sup></b>
    *ѴȤλؿ e ֤ͤޤ m  {@link #mant} ݻƤޤ<br>
    *BigDecimal βɬפʾϥ饹 {@link BDtoE_Form} Ȥޤ
    * @return ؿ e
    */
    public static int getExp10(BigDecimal x) {
        if (x.signum() == 0) { mant = 0;  return 0; }
        int exp = biFig10(x.unscaledValue()) - x.scale() - 1;
        BigDecimal mx = x.movePointLeft(exp), tm = mx;  // mx x ββ
    // ¿ȲdoubleValue()˻֤뤿ڤΤƤ롣
        tm = tm.divide(ONE, DOUBLE_PREC * 2, BigDecimal.ROUND_HALF_UP);  // 1 ǳäƤ롣
        mant = tm.doubleValue();
        // ؿĴ
        double p = Math.abs(mant);
        if (p == 1.0 || p == 10.0) { // |x| 1ޤ10˶ᤤͤľ硣
            if (x.signum() < 0) mx = mx.negate();
            while (mx.compareTo(ONE) < 0) {
                mant *= 10.0;  mx = mx.movePointRight(1);  exp--;
            }
            while (mx.compareTo(TEN) >= 0) {
                mant /= 10.0;  mx = mx.movePointLeft(1);   exp++;
            }
        } else {
            while (Math.abs(mant) < 1.0)  { mant *= 10.0; exp--; }
            while (Math.abs(mant) > 10.0) { mant /= 10.0; exp++; }
        }
        return exp;
    }
    /**
    *BigDecimal a, b Ѥ̥ӥåȤȲ̥ӥåȤȾʬʬƷ׻ޤ<br>
    *{@link BDMult#bdMult}ƤӽФƤޤ
    */
    public static BigDecimal bdMult(BigDecimal a, BigDecimal b, int precision) {
        return BDMult.bdMult(a, b, precision);
    }
    /**
    * BigDecimal x  <code><b>[+|-]a.bcd...e[+|-]xxx</b></code> Ѵʸ֤ޤ
    * ͤϤʤɤ˻Ȥޤ
    * x.doubleValue(); ǤϥСե礬뤿Ƥޤ
    */
    public static String toDoubleString(BigDecimal x) {
        if (x.signum() == 0) return new String("0.0");
        int exp = getExp10(x);

        return Double.toString(mant) + "e" + Integer.toString(exp);
    }

    /**
    * BigDecimal x  p ڤ <code><b>[+|-]a.bcd...E[+|-]xxx</b></code> ǽϤޤ
    * 2ʤǤΥӥåȿûƤ10ʤǤΤ줬ĹϽϤ<br>
    *<code>x = BDTools.roundOff(x, precision);</code><br>
    *¹ԤƤ
    * @param newLine ԤƽϤ true Ϳޤ
    * @return 10 ɽǤνϷ֤ޤ
    */
    public static int print(BigDecimal x, int p, boolean newLine) {
        System.out.println(toE_FormString(x, p, newLine));
        return decNumber;
    }
    /**
    * BigDecimal x  p ڤ <code><b>[+|-]a.bcd...E[+|-]xxx</b></code> ǽϤޤ
    * ϤȲԤޤ
    * @return 10 ɽǤνϷ֤ޤ
    */
    public static int print(BigDecimal x, int p) {  return print(x, p, true); }
    /**
    * BigDecimal x  p ڤ <code><b>[+|-]a.bcd... e[+|-]xxx</b></code> ʸѴޤ
    *  0 Ͻ졤ϤȲԤޤ<br>
    * p  0 ˤȶԤ줺Τޤ BigDecimal Υ󥹥ȥ饯
    * public BigDecimal(String val)  val ˻ѤǤޤ
    * 10 ɽǤη BDTools.decNumber äƤޤ
    */
    public static String toE_FormString(BigDecimal x, int p) { return toE_FormString(x, p, true); }
    /**
    * BigDecimal x  p ڤ <code><b>[+|-]a.bcd...E[+|-]xxx</b></code> ʸѴޤ
    *  0 Ͻޤp  0 ˤȶԤ줺Τޤ BigDecimal Υ󥹥ȥ饯
    * public BigDecimal(String val)  val ˻ѤǤޤ
    * @param newLine ԤƽϤ true Ϳޤ<br>
    * p 礭 x ûξ p  newLine λ̵뤵ޤ
    */
    public static String toE_FormString(BigDecimal x, int p, boolean newLine) {
        decNumber = 0;
        if (x.signum() == 0) return new String("0.0");
        if (precision > 0) x = roundOff(x, precision);

        int notNum = x.signum() > 0 ? 1 : 2;   //  '-' ̵ͭȾ '.'
        BDtoE_Form bdE = new BDtoE_Form(x); // BDtoE_Form.java ˤ롣 0 ޤǤ롣
        int    exp  = bdE.exp();    // ؿ
        double mant = bdE.mant();   // (double)
        BigDecimal xMant = bdE.bdMant();    // (BigDecimal)

        if (xMant.compareTo(new BigDecimal(mant)) == 0) { // bdEffFig10(x) < 16 ȽϤᡣ
            // x == mant, "2.0" ʤɲԤפûξ硣
            String s = Double.toString(mant);   // 1.0 <= mant < 10.0 Ǥ뤫 s ˤϻؿ Ennn դƤʤ
            decNumber = s.length() - notNum;

            return s + "E" + Integer.toString(exp);
        }

        String s = xMant.toString();
        if (p > s.length() || p <= 0) {
            decNumber = s.length() - notNum;
        // BigDecimal Υ󥹥ȥ饯 BigDecimal(String) ˻Ѳǽˤ뤿 " E" ȤϤʤ
            return s + "E" + Integer.toString(exp);
        }
        char r[] = s.toCharArray();
        final char DELMT = ' ';  // ڤʸ
        int decLen = r.length;
        StringBuffer sb = new StringBuffer(decLen); // ưṲ̄
        int i = 0;

        do {    // 桤
            sb.append(r, i, 1);     decLen--;
        } while (r[i++] != '.');

        if (newLine) sb.append("+\n");

        int iRem = decLen % p, iMax = i + decLen - iRem;    // (iMax - i)  p ܿ

        for (; i < iMax; i += p) {
            sb.append(r, i, p); sb.append(DELMT);
        }
        if (iRem != 0){
            sb.append(r, i, iRem);  i += iRem;
        }
        decNumber = i - notNum;
        int last = sb.length() -1;
        if (sb.charAt(last) == DELMT) sb.deleteCharAt(last);  // Ǹʸڤʸʤ롣
        // ؿɲáϸ䤹褦 " E" Ȥ롣
        //  readNumber() ɤ߹߲ǽ
        return sb.toString() + " E" + Integer.toString(exp);
    }
    /**
    * ĤBigDecimal a, b פ뤫֤ޤ
    */
    public static int agreeUpTo(BigDecimal a, BigDecimal b) {
        BDtoE_Form bdeA = new BDtoE_Form(a);
        BDtoE_Form bdeB = new BDtoE_Form(b);
        if (bdeA.exp() != bdeB.exp()) return 0; // if ( a.scale() != b.scale()) return 0; ǤϤᡣ

        char[] sa = bdeA.bdMant().toString().toCharArray();
        char[] sb = bdeB.bdMant().toString().toCharArray();
        int num = 0, iMax = Math.min(sa.length, sb.length);

        for (int i = 0; i < iMax && sa[i] == sb[i]; i++)
            if (Character.isDigit(sa[i])) num++;
        return num;
    }

    private static boolean skip(int c) {
        return c == ' ' || c == '\r' || c == '\n' || c == '+';
    }
    /**
    * BigDecimal ͤե뤫ɤ߹ߤޤprecision ˤ 10 ʤǤηͿޤ
    * ºݤɤ߹ {@link #decNumber} äƤޤ
    * precision 礭 decNumber &lt; precision Ȥʤޤ<br>
    * ͤ˲ԡ'+'椬äƤƤ⤫ޤޤ
    *@param fileName ϥե̾Ϳޤ
    *@return ɤ߹ BigDecimal ֤ͤޤե뤬Ĥʤ <code>null</code> ֤ޤ
    */
    public static BigDecimal readNumber(String fileName, int precision) throws IOException {
        BufferedReader in;
        try { in = new BufferedReader(new FileReader(fileName));
        } catch (FileNotFoundException e) { return null; }
        StringBuffer sb = new StringBuffer();
        int c, len = 0;

        do { //  "[+|-]a."
            if ((c = in.read()) == -1) break;
            sb.append((char)c);
            if (Character.isDigit((char)c)) len++;
        } while (len < precision && c != '.');

        while (c != -1 && len < precision) { //  "bcdef..."
            c = in.read();
            if (c == 'e' || c == 'E') break;
            if (Character.isDigit((char)c)) {
                sb.append((char)c); len++;
            }
        }

        if (c != -1) { // ؿ "E[+|-]xyz" õ
            while (c != 'e' && c != 'E' && c != -1) c = in.read();
            while (c != -1 && !skip(c)) {
                sb.append((char)c); c = in.read();
            }
        }
        in.close();
        decNumber = len;
        return new BigDecimal(sb.toString());
    }
}
