/**
* BinarySplit1.java -- binary splitting method ݥ饹
* Ȥäľˡ
* ƵƤӽǤ BinarySplit2.java
* BDTools.javaBigDecimal ƻ񽸡ˤѤƤ롣
* @version $Revision: 1.1 $, $Date: 2003/03/20 02:30:36 $
*/

import java.math.*;  // BigDecimal 饹Ȥ

/**
* binary splitting ˡݥ饹(abstract class)Ǥ
* ȤäľˡǤ<br>
* <b>ˡ</b><br>
* {@link #bsA}ʤɤA<sub>k</sub>, B<sub>k</sub>, C<sub>k</sub>ơ<br>
* {@link #set}<br>
* {@link #putTogether}<br>
* {@link #getValue}<br>
*ν˸ƤӽФƤƥƥåפν֤¬礬뤿ᡤʬ䤷Ƥޤ
* @see BDTools
* @see BinarySplitE
* @see BinarySplit2
* @see BinarySplitPi2
*/
public abstract class BinarySplit1 {
/////// ʸȾȤ餷碌ɤߤ䤹褦 L,N,A,B,C ʸȤäƤ롣 ///////
    private int L;  //  L = 2^p Ǥ뤳ȡ
    private int N;
    BigDecimal[] A, B, C;
    BigDecimal result;
    static int ceilpow2(int sz) { // sz <= k = 2^n Ǿ k ֤sz <= 0 ξ0֤
        if (sz < 2) return sz > 0 ? 1 : 0;
        int k = 2;

        while (k < sz) k *= 2;
        return k;
    }
    /**
    * 10 ʤǤ١ͭˤ֤ޤ
    */
    public int N() { return N; }
    /**
    * ºݤι֤ޤ
    */
    public int upTo() { return L; }
    /**
    * 桼 <code>BinarySplitE(int nint f) { super(n, f); }</code> Τ褦ʥ󥹥ȥ饯
    * ɬפޤ
    * @see BinarySplitE
    * @param upto ιꤷޤupto = 2<sup><i>n</i></sup> ˤʤ褦Ĵޤ
    * @param N ͭꤷޤ
    */
    public BinarySplit1(int upto, int N) {
        L = ceilpow2(upto); // ʸǤ ceilpow2() ϻȤäƤʤ
        this.N = N;
        A = new BigDecimal[L];  B = new BigDecimal[L];  C = new BigDecimal[L];
    }
    /**
    * A<sub>k</sub> ֤ݥ᥽åɤǤ<br>
    * 桼С饤ɤɬפޤ
    */
    public abstract BigDecimal bsA(int k);
    /**
    * B<sub>k</sub> ֤ݥ᥽åɤǤ<br>
    * 桼С饤ɤɬפޤ
    */
    public abstract BigDecimal bsB(int k);
    /**
    * C<sub>k</sub> ֤ݥ᥽åɤǤ<br>
    * 桼С饤ɤɬפޤ
    */
    public abstract BigDecimal bsC(int k);

    /**
    * <code>A[0..L-1], B[0..L-1], C[0..L-1]</code> 򥻥åȤޤ
    */
    public void set() {
        for (int i = 0; i < L; i++){
            A[i] = bsA(i);  B[i] = bsB(i);  C[i] = bsC(i);
        }
    }

    /**
    * Ԥޤ
    */

    public void putTogether() {
        int n = L / 2;
        while (n != 0){
            for (int k = 0; k < n; k++){
                BigDecimal p = BDMult.bdMult(A[2 * k], C[2 * k + 1], N);

                A[k] = p.add(BDMult.bdMult(B[2 * k], A[2 * k + 1], N));
                B[k] = BDMult.bdMult(B[2 * k], B[2 * k + 1], N);
                C[k] = BDMult.bdMult(C[2 * k], C[2 * k + 1], N);
            }
            n /= 2;
        }
    }
    /**
    * ¤ BigDecimal ֤ޤ
    * @param inv <code>C[0]/A[0]</code>ˤ <code>true</code> 
    *<code>A[0]/C[0]</code> ξ <code>false</code> Ϳޤ
    */
    public BigDecimal getValue(boolean inv) {
        if (inv) result = C[0].divide(A[0], N, BigDecimal.ROUND_HALF_EVEN); // C[0]/A[0]
        else     result = A[0].divide(C[0], N, BigDecimal.ROUND_HALF_EVEN); // A[0]/C[0]

        return result;
    }
}
