/**
 * BitOutputStream.java -- ӥåȽϥȥ꡼
 *
 * @version $Revision: 1.7 $, $Date: 2003/03/22 02:31:14 $
 */

import java.io.*;
/**
* HuffmanˡʤɤǻȤӥåȽϥ롼Ǥ
* @see BitInputStream
* @see Huffman
* @see Slide
* @see Squeeze
*/
public class BitOutputStream extends FilterOutputStream {
    public static final int MAX_BITS = 31;  // 񤭹߲ǽʺӥåȿ
    protected int putCount = 8; // ӥåȽϥ
    protected int bitBuf = 0;   // ӥåȽϥХåե
    protected int outCount = 0; // ХȽϥ
    /**
    * 󥹥ȥ饯
    * @param out ϥȥ꡼
    */
    public BitOutputStream(OutputStream out) {  super(out);  }
    /**
    * ϥХȿ֤
    */
    public int outCount() {  return outCount;  }
    /**
     * x α¦ n ӥåȤ֤
     */
    private static int rightBits(int n, int x) {
         return x & ((1 << n) - 1);
    }
    /**
    * 1ӥåȤ
    */
    public void putBit(boolean bit) throws IOException {
        putCount--;
        if (bit) bitBuf |= (1 << putCount);
        if (putCount == 0) {
            out.write(bitBuf);
            bitBuf = 0;  putCount = 8;  outCount++;
        }
    }
    /**
    * x α¦ n ӥåȤ
    */
    public void putBits(int n, int x) throws IOException {
        while (n >= putCount) {
            n -= putCount;
            bitBuf |= rightBits(putCount, x >>> n);
            out.write(bitBuf);
            bitBuf = 0;  putCount = 8;  outCount++;
        }
        putCount -= n;
        bitBuf |= rightBits(n, x) << putCount;
    }
    /**
    * ȥ꡼򥯥
    */
    public void close() throws IOException {
        putBits(7, 0);  super.close();  // Хåեեå
    }
}
