/**
 *  ͥõ
 *
 *  @version $Revision: 1.7 $, $Date: 2003/04/28 23:23:14 $
 */

public class BreadthFirstSearch {
    static int n;  // ο
    static int[][] adjacent;  // ܹ

    public static void readGraph() { // 
        n = 7;  // ο ()
        int data[] = { 1, 2, 2, 3, 1, 3, 2, 4, 5, 7 };  // ܥꥹȤˤ
                                                        // ǡ ()
        adjacent = new int[n + 1][n + 1];
        for (int i = 1; i <= n; i++)
            for (int j = 1; j <= n; j++) adjacent[i][j] = 0;

        for (int k = 0; k + 1 < data.length; k += 2) {
            int i = data[k],  j = data[k + 1];
            adjacent[i][j] = adjacent[j][i] = 1;
        }
        System.out.println("ܹ:");
        for (int i = 1; i <= n; i++) {
            for (int j = 1; j <= n; j++)
                System.out.print(" " + adjacent[i][j]);
            System.out.println();
        }
    }

    public static void main(String[] args) {
        readGraph();
        int[] distance = new int[n + 1],  prev = new int[n + 1];
        for (int i = 1; i <= n; i++) distance[i] = -1;  // ̤ˬ
        int[] fifo = new int[n];  // Ԥ(FIFO)
        int in = 0,  out = 0;  // FIFOХåեΥݥ

        final int START =  1;
        fifo[in++] = START;  distance[START] = 0;
        do {
            int i = fifo[out++];  // Ԥ󤫤μФ
            for (int j = 1; j <= n; j++)
                if (adjacent[i][j] != 0 && distance[j] < 0) {
                    fifo[in++] = j;  // Ԥؤ
                    distance[j] = distance[i] + 1;  prev[j] = i;
                }
        } while (in != out);  // Ԥ󤬶ʤ齪λ

        System.out.println("  ľ  ûΥ");
        for (int i = 1; i <= n; i++)
            if (distance[i] > 0)
                System.out.println(" " + i + "         "
                    + prev[i] + "         " + distance[i]);
    }
}
