/**
 *  ʣǥ٥ȥ륯饹
 *
 *  ʣǥ٥ȥ(Complex )ФƼ黻᥽åɤ󶡤ޤ
 *
 *  @version $Revision: 1.6 $, $Date: 2003/03/13 14:24:30 $
 */
public class CVector {
    /**
     *  ʣǶ٥ȥ֤ޤ
     *  @return v<sup>*</sup>
     */
    public static Complex[] conj(Complex[] v) {
        Complex[] ret = new Complex[v.length];
        for (int i = 0; i < v.length; i++) ret[i] = v[i].conj();
        return ret;
    }
    /**
     *  ͤ (lhs + rhs) Ȥʤ٥ȥ֤ޤ
     *  @param  lhs 
     *  @param  rhs 
     *  @return (lhs + rhs)
     */
    public static Complex[] add(Complex[] lhs, Complex[] rhs) {
        if (lhs.length != rhs.length)
            throw new IndexOutOfBoundsException();
        Complex[] ret = new Complex[lhs.length];
        for (int i = 0; i < lhs.length; i++) ret[i] = lhs[i].add(rhs[i]);
        return ret;
    }
    /**
     *  ͤ (this - rhs) Ȥʤ٥ȥ֤ޤ
     *  @param  rhs Υ٥ȥ˲ä
     *  @return (this - rhs)
     */
    public static Complex[] subtract(Complex[] lhs, Complex[] rhs) {
        if (lhs.length != rhs.length)
            throw new IndexOutOfBoundsException();
        Complex[] ret = new Complex[lhs.length];
        for (int i = 0; i < lhs.length; i++) ret[i] = lhs[i].subtract(rhs[i]);
        return ret;
    }
    /**
     *  ͤ (z * v) Ȥʤ٥ȥ֤ޤ
     *  @param  z   顼
     *  @param  v   ٥ȥ
     *  @return (z * v)
     */
    public static Complex[] multiply(Complex z, Complex[] v) {
        Complex[] ret = new Complex[v.length];
        for (int i = 0; i < v.length; i++) ret[i] = z.multiply(v[i]);
        return ret;
    }
    /**
     *  lhs[ns]<sup>*</sup>*rhs[ns]+..+
     *  lhs[ne-1]<sup>*</sup>*rhs[ne-1] ֤ޤ
     *  @param  ns  ¤ǽֹ
     *  @param  ne  ¤ǸǤμֹ
     *  @param  lhs 
     *  @param  rhs 
     *  @return 黻η
     */
    public static Complex innerProduct(int ns, int ne,
                                       Complex[] lhs, Complex[] rhs) {
        if (ns < 0 || ne < 0 || ns > ne) throw new IndexOutOfBoundsException();
        double re = 0.0, im = 0.0;
        for (int i = ns; i < ne; i++) {
            Complex value = lhs[i].conj().multiply(rhs[i]);
            re += value.re(); im += value.im();
        }
        return new Complex(re,im);
    }
    /**
     *  ٥ȥ ns ܤǤǸǤޤǤѤ֤ޤ
     *  @param  ns  ¤ǽֹ
     *  @param  lhs 
     *  @param  rhs 
     *  @return Ѥ
     */
    public static Complex innerProduct(int ns, Complex[] lhs, Complex[] rhs) {
        return innerProduct(ns, lhs.length, lhs, rhs);
    }
    /**
     *  ٥ȥѤ֤ޤ
     *  @param  lhs 
     *  @param  rhs 
     *  @return Ѥ
     */
    public static Complex innerProduct(Complex[] lhs, Complex[] rhs) {
        return innerProduct(0, lhs.length, lhs, rhs);
    }
}

