/*
* CondNum.java -- 
* @version $Revision: 1.4 $, $Date: 2003/03/13 14:24:31 $
* class RMatrix, LUMatInv, LU Ȥ
*/

import java.io.*;

/**
* ξޤ
* @see LUMatInv
* @see RMatrix
*/
public class CondNum {
    static double infinityNorm(double[][] a) { // Υ
        int n = a.length;
        double max = 0;
        for (int i = 0; i < n; i++) {
            double rowSum = 0;
            for (int j = 0; j < n; j++) rowSum += Math.abs(a[i][j]);
            if (rowSum > max) max = rowSum;
        }
        return max;
    }
    /**
    * ξޤ
    * @param a ᤿ <code>a[0..n-1][0..n-1]</code> Ϳޤ
    * @return  <code>a[][]</code> ξ֤ޤ
    */
    public static double getValue(double[][] a) { // 
        int n = a.length;
        double[][] aInv = new double[n][n];
        double t = infinityNorm(a);

        if (LUMatInv.inverse(a, aInv) == 0)  // mathutils.LUMatInv
            throw new Error("չ󤬤ޤ");
        return t * infinityNorm(aInv);
    }
    /**
    * ȤäƥȥץǤ<br>
    * ǽ˹μ n Ϥޤ
    */
    public static void main(String[] args) throws IOException {
        BufferedReader in = new
            BufferedReader(new InputStreamReader(System.in));

        System.out.print("μ n = ");
        int n = Integer.parseInt(in.readLine());    // μ
        double[][] a = new double[n][n];

        for (int i = 0; i < n; i++)
            for (int j = 0; j < n; j++)
                a[i][j] = Math.random() - Math.random();

        RMatrix.print(a, 7, "10.6f");
        System.out.println(" = " + getValue(a));
    }
}
