/*
* GCDandLCM.java --  J. Stein ˡǵ롣
* gcd르ꥺ
* @version $Revision: 1.5 $, $Date: 2002/12/16 01:03:24 $
*/

/**
*  J. Stein ˡʣgcd르ꥺˤǵޤ
* @see GCD
*/
public class GCDandLCM {
    /**
    * Ĥμκ򣲿gcd르ꥺǵޤ
    * @param u 
    * @param v 
    * @return <code>gcd(u,v)</code>
    */
    public static long gcd(long u, long v) {
        if (u <= 0 || v <= 0) throw new Error("顼 : gcd(u,v)");
        if (u == 1 || v == 1) return 1;
        long d = 1, t;
        while ((u % 2) == 0 && (v % 2) == 0) { // u, v ɤ餫ˤʤޤ2ǳ롣
            d *= 2;  u /= 2;  v /= 2; // d ˽򵭲Ƥ
        }
        if ((u % 2) != 0) t = -v;
        else              t = u;
        while (t != 0) {
            while ((Math.abs(t) % 2) == 0) t /= 2;
            if (t > 0) u =  t;
            else       v = -t;
            t = u - v;
        }
        return u * d;
    }

    /**
    * ĤμκǾܿޤ
    * @param a 
    * @param b 
    * @return <code>lcm(a,b)</code>
    */ 
    public static long lcm(long a, long b) {
        // Ǥ夢դɻߤ뤿礭˳롣
        return a > b ? (a / gcd(a, b)) * b : a * (b / gcd(a, b));
    }
/**
* ƥѤǤ
*/
    public static void main(String[] args) {
        long a = 40902, b = 24140;

        System.out.println("GCD(" + a + "," + b + ") = " + gcd(a, b)); // 34 ˤʤϤ
        System.out.println("LCM(" + a + "," + b + ") = " + lcm(a, b));
    }
}
