/*
* GaussElimination.java -- Gauss () ˡ
* @version $Revision: 1.6 $, $Date: 2003/03/13 14:24:32 $
* class RMatrix Ȥ
*/
import java.io.*;

/**
* ϢΩ켡 Gauss ˡǲ򤭤ޤ
*@see RMatrix
*@see NumberFormatter
*@see GaussSeidel
*@see Gauss3
*@see Gauss5
*/

public class GaussElimination {
    /**
    * ϢΩ켡 Gauss ˡǲ򤭤ޤ
    *@param a <code>a<sub>ij</sub> = a[i-1][j-1], b<sub>j</sub> = a[j-1][n]<br></code>
    * x<sub>j</sub>  <code>a[j-1][n]</code> ˾񤭤ޤ
    */
    public static void solve(double[][] a) {
        int n = a.length; // n=a[][]ιԿʤ̤οο

        for (int k = 0; k < n - 1; k++) {
            for (int i = k + 1; i < n; i++) {
                double t = a[i][k] / a[k][k];
                for (int j = k + 1; j <= n; j++) a[i][j] -= t * a[k][j];
            }
        }
        for (int i = n - 1; i >= 0; i--) {
            double t = a[i][n];
            for (int j = i + 1; j < n; j++) t -= a[i][j] * a[j][n];
            a[i][n] = t / a[i][i];
        }
    }

    /**
    * ץǤ
    *n = ʹƤޤ̤οθĿϤƤ<br>
    *<b>&quot;, Ȥξդκ&quot;</b>ɽޤ
    */
    public static void main(String[] args) throws IOException {
        BufferedReader in = new
            BufferedReader(new InputStreamReader(System.in));
        NumberFormatter fmt7f = new NumberFormatter("13.7f"),
                        fmt7e = new NumberFormatter("18.7e"),
                        fmt3d = new NumberFormatter("3d");
        System.out.print("n = ");
        int n = Integer.parseInt(in.readLine());
        double[][] a = new double [n][n + 1], b = new double [n][n + 1];

        for (int i = 0; i < n; i++)
            for (int j = 0; j < n; j++)
                a[i][j] = b[i][j] = Math.random() - Math.random();
        for (int i = 0; i < n; i++)
            a[i][n] = b[i][n] = Math.random() - Math.random();
        System.out.println(" (դޤ)");
        RMatrix.print(a, 10, "7.3f");
        solve(a);
        System.out.println(", Ȥξդκ");
        for (int i = 0; i < n; i++) {
            double s = b[i][n];
            for (int j = 0; j < n; j++) s -= b[i][j] * a[j][n];
            System.out.println(fmt3d.toString(i) + ": " + fmt7f.toString(a[i][n])
                + fmt7e.toString(s));
        }
    }
}
