/**
 *  ǿLucasƥ 
 *
 *  $Revision: 1.3 $, $Date: 2003/04/28 23:23:17 $
 */

public class Lucas2 {
    /** 2^p-1 ǿʤ true ֤ (p3ʾǿ) */
    public static boolean isMersennePrime(final int p) {
        int[] a = new int[p + 1],  x = new int[p + 1];  // +1 ֿ
        for (int i = 0; i < p; i++) a[i] = 0;
        a[2] = 1;  // a = 4

        for (int k = 2; k < p; k++) {
            System.err.print((p - k) + " \r");  // ʸϺ
            int[] swap = x;  x = a;  a = swap;  // x = a
            for (int i = 0; i < p; i++) a[i] = 1;
            a[1] = 0;  // a = -2 mod M_p
            for (int i = 0; i < p; i++)  // a = (a + x ^ 2) mod M_p
                if (x[i] > 0) {
                    int s = 0,  h = i;
                    for (int j = 0; j < p; j++) {
                        s = s / 2 + a[h] + x[j];
                        a[h] = s % 2;  if (++h == p) h = 0;
                    }
                    if (s > 1) {  // Ǹη夬
                        while (a[h] > 0) {
                            a[h] = 0;  if (++h == p) h = 0;
                        }
                        a[h] = 1;
                    }
                }
        }
        a[p] = 1 - a[0];  // ֿ
        int i = 1;  while (a[i] == a[0]) i++;
        return (i == p);  // a == 0  a == M_p  true
    }

    public static void main(String[] args) {
        if (args.length != 1) {
            System.out.println("ˡ: java Lucas2 p");
            return;
        }
        final int p = Integer.parseInt(args[0]);
        if (p < 3) {
            System.out.println("ʾǿꤷƲ");
            return;
        }
        System.out.println("2^" + p + "-1  ...");
        if (isMersennePrime(p)) System.out.println("ǿǤ");
        else                    System.out.println("Ǥ");
    }
}
