/*
* NumInteg.java -- ʬ
* @version $Revision: 1.7 $, $Date: 2003/03/13 14:24:33 $
*/

/**
*ʬ§§Simpson§ˤΥץǤ
*@see UseNumInteg
*/

public class NumInteg {
    static final int N_MAX = 32;

    /**
    *ʬؿ f(x)Ϳޤ
    */
    public double f(double x) { // ʬؿ $f(x)$
        return  1 / x;
    }
    /**
    *ʬѤ(1, 2, 4,...32)Ĥˡ§§Simpson§
    *η̤ɽޤ
    *@param a 
    *@param b 
    *@return ʬ 32 ΤȤ Simpson §η׻
    */
    public double evaluate(double a, double b) {
        NumberFormatter fmtd = new NumberFormatter("2d"),
                        fmtf = new NumberFormatter("10.6f");
        double simpson = 0;
        double h = b - a, trapezoid = h * (f(a) + f(b)) / 2;

        System.out.println(" n                 Simpson");
        for (int n = 1; n <= N_MAX; n *= 2) {
            double midpoint = 0;
            for (int i = 1; i <= n; i++)
                midpoint += f(a + h * (i - 0.5));
            midpoint *= h;  simpson = (trapezoid + 2 * midpoint) / 3;
            System.out.println(fmtd.toString(n) + "  "
                + fmtf.toString(trapezoid) + fmtf.toString(midpoint)
                + fmtf.toString(simpson));
            h /= 2;  trapezoid = (trapezoid + midpoint) / 2;
        }
        return simpson;
    }
    /**
    *ʬؿ f(x) = 1 / x,  a = 1,  b = e ͿȤΥץǤ
    *ͤ log e = 1.0 Ǥ
    */
    public static void main(String[] args) {
        NumInteg ni = new NumInteg();
        double r = ni.evaluate(1, Math.E);
        System.out.println("\n = " + Math.log(Math.E) + "   = " + (1.0 - r));
    }
}
