/**
 * RadixConversion.java -- Ѵ
 * @version $Revision: 1.3 $, $Date: 2002/12/16 01:03:27 $
*/
import java.io.*;
import java.util.*;

/**
* û(long ͤϰ)δѴץǤ
*/

public class RadixConversion {
    // ʸǤϳ饹ȤƤ롣
    static class IntArray {
    // (0 ǤʤƬη)ݻФ褤ʣˤʤ뤿äƤʤ
        int radix; // 
        int size;  // 
        int[] c;
        IntArray(int radix, int size) {
            this.radix = radix;   c = new int[this.size = size];
        }
        void init() { Arrays.fill(c, 0); } // 0 ǽ
    }

    static int longToArray(long x, IntArray y) {
        int i, d = y.radix;

        y.init();
        for (i = 0; x != 0 && i < y.size; i++) {
            y.c[i] = (int)(x % d);  x /= d;
        }
        if (x == 0) return i;   /*  */
        else        return -1;  /* 顼 */
    }

    static int arrayToArray(IntArray src, IntArray dst) { // src Ƥϲ
        dst.init();
        int i, ms = src.size, md = dst.size,
            rs = src.radix, rd = dst.radix;

        for (i = 0; ms > 0 && i < md; i++) {
            int r = 0;
            for (int j = ms - 1; j >= 0; j--) {
                int t = rs * r + src.c[j];   src.c[j] = t / rd;
                r = t % rd;
            }
            dst.c[i] = r;
            while (ms > 0 && src.c[ms - 1] == 0) ms--;
        }
        if (ms == 0) return i;   /*  */
        else         return -1;  /* 顼 */
    }

    static long arrayToLong(IntArray x) { // dʢ10
        int m = x.size - 1;
        // ΣԤϤʤƤ褤
        while (m > 0 && x.c[m] == 0) m--; // 0 ǤʤƬηõ
        if (m == 0) return 0; // Ƥη夬 0
        // y Ƭη
        long y = x.c[m--], d = (long)x.radix;

        for ( ; m >= 0; m--) y = y * d + x.c[m]; // Horner ˡ
        return y;
    }

    static final int M = 100;
    /**
    * ץǤ<br>
    * <b>&quot;x = &quot;</b>ʹƤޤ顤οͤ long ϰ(19)
    * ϤƤ<br>
    * 8 ʡ2 ʤѴ̤ɽޤ
    */

    public static void main(String[] args) throws IOException {
        BufferedReader in = new
            BufferedReader(new InputStreamReader(System.in));
        System.out.print("x = ");
        long x = Long.parseLong(in.readLine());
        IntArray x8 = new IntArray(8, M);
        IntArray x2 = new IntArray(2, M);
        int m1 = longToArray(x, x8);

        if (m1 < 0) {
            System.out.println("longToArray: error");  System.exit(-1);
        }

        System.out.print("8(octal)   : ");
        for (int i = m1 - 1; i >= 0; i--) System.out.print(x8.c[i]);
        System.out.println();
        System.out.println("toOctalString: " + Long.toOctalString(x));

        int m2 = arrayToArray(x8, x2);
        if (m2 < 0) {
            System.out.println("arrayToArray: error");  System.exit(-1);
        }

        System.out.print("2(binary)   : ");
        for (int i = m2 - 1; i >= 0; i--) System.out.print(x2.c[i]);
        System.out.println();
        System.out.println("toBinaryString: " + Long.toBinaryString(x));

        longToArray(x, x8); // arrayToArray()  x8 ƤϲƤ뤿Ѵ
        System.out.println("8ʢ10: " + arrayToLong(x8));
        System.out.println("2ʢ10: " + arrayToLong(x2));
        System.out.println("2ĤȤϤͤϤ");
    }
}
