/*
* SInteger.java -- ¿Ĺ饹
* @version $Revision: 1.7 $, $Date: 2003/04/01 12:35:49 $
*/
import java.math.*;
import java.util.*;

/**
* 10,000¿Ĺ饹Ǥ
* FFT 軻ΥƥȡץѤǤäơɬ׺Ǿ¤εǽäƤޤ
*/

public class SInteger {
    static final int FIGURES  = 4;
    /**
    * (= 10,000)ݻƤޤ
    */
    public static final short RADIX = 10000; //  10^FIGURES
    /**
    *  BigInteger ɽݻƤޤ
    */
    public static final BigInteger BI_RADIX = BigInteger.valueOf(RADIX);
    /**
    * ƷݻƤޤf[i] < RADIX Ǥ
    */
    public short[] f;   // static ˤƤϤʤ
    /**
    * 10,000ǤηݻƤޤ
    * <code>size = 2<sup>n</sup></code>Ǥ
    */
    public int size;    // Ʊ size = 2^n ˤȤ

    static int ceilpow2(int sz) { // sz <= k = 2^n Ǿ k ֤sz <= 0 ξ0֤
        if (sz < 2) return sz > 0 ? 1 : 0;
        int k = 2;

        while (k < sz) k *= 2;
        return k;
    }
    /**
    * @param size 10,000ǤηͿޤ
    * <code>size = 2<sup>n</sup></code> ˤʤ褦Ĵޤ
    */
    public SInteger(int size) {
        f = new short[this.size = ceilpow2(size)];
    }
    /**
    * SInteger  BigInteger Ѵ󶡤ޤ
    */
    public BigInteger toBigInteger() {
        int i = size - 1;
        while (f[i] == 0 && i >=0) i--;
        if (i < 0) i = 0;
        BigInteger biVal = BigInteger.valueOf(f[i--]); // Ǿ̤η

        for (; i >= 0; i--) { // Horner ˡǷ׻
            biVal = biVal.multiply(BI_RADIX);
            biVal = biVal.add(BigInteger.valueOf(f[i]));
        }
        return biVal;
    }
    /**
    * SInteger ɽΤޤ޽Ϥޤ
    */
    public void print() {
        NumberFormatter fmt04d = new NumberFormatter("04d");
        NumberFormatter fmt4d  = new NumberFormatter("4d");
        int i = size - 1;
        while (f[i] == 0) {
            i--;
            if (i < 0) { System.out.println("0");    return; }
        }
        System.out.print(fmt4d.toString(f[i--]) + " "); // Ǿ̤η
        for (; i >= 0; i--) System.out.print(fmt04d.toString(f[i]) + ' ');
        System.out.println();
    }
    /**
    * SInteger ֥Ȥ size 򥻥åȤޤ
    */
    public void setRandom(int size) {
        int cs = ceilpow2(size);
        if (this.size != cs) f = new short[this.size = cs];
        for (int i = 0; i < size; i++) f[i] = (short)(Math.random() * RADIX); // f[i] < RADIX
    }
}
