/**
 *  ȿõ(Ƭưˡ)
 *
 *  @version $Revision: 1.4 $, $Date: 2003/04/28 23:23:19 $
 */

import java.io.*;

public class SelfOrganizeSearch2 {
    class Item {
        Item next;  String key, info;
        Item(Item next, String key, String info) {
            this.next = next;  this.key = key;  this.info = info;
        }
    }

    Item head;  // ꥹȤƬ

    public SelfOrganizeSearch2() {
        head = new Item(null, null, null);
        head.next = head;
    }

    public void add(String key, String info) {
        Item item = new Item(head.next, key, info);
        head.next = item;
    }

    public String getInfo(String key) {
        head.key = key;  // ֿ
        Item p = head,  q;
        do {
            q = p;  p = p.next;
        } while (!p.key.equals(key));
        if (p == head) return null;
        q.next = p.next;  p.next = head.next;  head.next = p;
        return p.info;
    }

    public static void main(String[] args) throws IOException {
        BufferedReader input =
            new BufferedReader(new InputStreamReader(System.in));
        SelfOrganizeSearch2 list = new SelfOrganizeSearch2();

        for ( ; ; ) {
            String key, info;
            System.out.print("̾? ");
            if ((key = input.readLine()) == null) break;
            if ((info = list.getInfo(key)) != null)
                System.out.println(": " + info);
            else {
                System.out.print("? ");
                if ((info = input.readLine()) != null)
                    list.add(key, info);
            }
        }
    }
}
