import java.io.*;

/**
 *  ¿̥ǡɹߴط롼
 *
 *  @version $Revision: 1.4 $, $Date: 2003/03/13 14:24:36 $
 */
public class StatData {
    /**
     *  ɹߥ顼ꤲ㳰
     */
    public class ReadError extends RuntimeException {}

    private Reader input;
    private StreamTokenizer in;
    private int nRows, nCols;

    /**
     *  ǡեɤि˳ǽˤϤη n
     *  ̤ο m ɤ߹ࡣ
     *
     *  @param  filename    ǡե̾
     *  @throw #ReadError
     *  @throw #MissingData
     */
    public StatData(String filename) {
        try {
            input = new FileReader(filename);
        } catch (FileNotFoundException e) { throw new ReadError(); }
        in = new StreamTokenizer(input);
        double x = getNum(), y = getNum();
        if (x <= 0 || x > Integer.MAX_VALUE ||
            y <= 0 || y > Integer.MAX_VALUE) {
            System.err.println("Կɤ߹ޤ");
            close(); throw new ReadError();
        }
        nRows = (int)x; nCols = (int)y;
        System.err.println(nRows + "  "
                         + nCols + " ΥǡǤ");
    }
    /**
     *  ǡեɹߤλ롣
     */
    public void close() { try { input.close(); } catch (Exception e) {} }
    /**
     *  ֤
     *
     *  @return 
     */
    public int numberOfRows() { return nRows; }
    /**
     *  ̤ο֤
     *
     *  @return 
     */
    public int numberOfColumns() { return nCols; }
    /**
     *  ǡե뤫飱ĤΥǡɤ߹ߡ֤ͤ
     *
     *  @return ɤ߹
     *  @throw #ReadError
     */
    public double getNum() {
        try {
            for (;;) {
                int ttype = in.nextToken();
                if (ttype == in.TT_EOF) { // ե뽪ü
                    close(); throw new ReadError();
                } else if (ttype == in.TT_NUMBER) { // 
                    return in.nval;
                } else if (ttype == '*') { // »
                    return Double.NaN;
                }
            }
        } catch (IOException e) { throw new ReadError(); }
    }
    /**
     *  ǡե뤫ǡɤ߹ΤȤ֤
     *
     *  @return ɤ߹
     *  @throw #ReadError
     */
    public double[][] readData() {
        double[][] m = new double[nCols][nRows];
        for (int i = 0; i < nRows; i++)
            for (int j = 0; j < nCols; j++)
                m[j][i] = getNum();
        close();
        return m;
    }
    /**
     *  ǡե뤫ǡɤ߹ΤȤ֤
     *
     *  @param  filename    ǡե̾
     *  @return ɤ߹
     *  @throw #ReadError
     */
    public static double[][] readData(String filename) {
        return new StatData(filename).readData();
    }
}

