/**
 *  ȥݥ롦ƥ
 *  ˡ: java TopologicSort < TopologicSort.data
 *
 *  @version $Revision: 1.3 $, $Date: 2003/04/28 23:23:20 $
 */

import java.io.*;
import java.util.*;

public class TopologicalSort {
    static int n;  // ο
    static int[][] adjacent;  // ܹ
    static int[] visited;
    static final int NEVER = 1;  // ޤˬƤʤ
    static final int JUST  = 2;  // õ
    static final int ONCE  = 3;  // ˬѤ

    public static void readGraph() throws IOException { // 
        BufferedReader input =
            new BufferedReader(new InputStreamReader(System.in));

        StringTokenizer t = new StringTokenizer(input.readLine());
        n = Integer.parseInt(t.nextToken());
        adjacent = new int[n + 1][n + 1];
        for (int i = 1; i <= n; i++)
            for (int j = 1; j <= n; j++) adjacent[i][j] = 0;

        String s;
        while ((s = input.readLine()) != null) {
            t = new StringTokenizer(s);
            int i = Integer.parseInt(t.nextToken());
            int j = Integer.parseInt(t.nextToken());
            adjacent[i][j] = 1;
        }

        System.out.println("ܹ:");
        for (int i = 1; i <= n; i++) {
            for (int j = 1; j <= n; j++)
                System.out.print(" " + adjacent[i][j]);
            System.out.println();
        }
    }

    public static void visit(final int i) {
        visited[i] = JUST;
        for (int j = 1; j <= n; j++) {
            if (adjacent[j][i] == 0) continue;
            if (visited[j] == NEVER) visit(j);
            else if (visited[j] == JUST)
                throw new Error("뤢!");
        }
        visited[i] = ONCE;  System.out.print(" " + i);
    }

    public static void main(String[] args) throws IOException {
        readGraph();  // ܹɤ
        visited = new int[n + 1];
        for (int i = 1; i <= n; i++) visited[i] = NEVER;
        System.out.println("ȥݥ롦ƥ󥰤η:");
        for (int i = 1; i <= n; i++)
            if (visited[i] == NEVER) visit(i);
        System.out.println();
    }
}
