/**
* UKanji.java -- եJISEUCѴ
*  @version $Revision: 1.1 $, $Date: 2003/04/04 11:18:23 $
*
* java UKanji < infile > outfile
*
* Τ褦˻Ȥ
* ȾѥʤäƤȡʬʸ롣
*
* Windowsʤɤ"\r\n"ΥڥUNIXϤ'\n'Ѵ褦ˤƤ롣
*/

import java.io.*;

/**
* ե JIS Υե EUC ΤΤѴޤ<br>
* Windows ʤɤ &quot;\r\n&quot; Υڥ UNIX Ϥ '\n' Ѵޤ<br>
* ˡ<code>java UKanji &lt; infile &gt; outfile</code>
* @see SJIStoEUC
*/

public class UKanji {
    static boolean isKanji(int c) { // եJIS 1Х
        return ((char)((c ^ 0x20) - 0xA1) <= 0x3B); // ʸ
//        return (c >= 0x81 && c <= 0x9F) || (c >= 0xE0 && c <= 0xFC);
    }
    static boolean isKanji2(int c) { // եJIS 2Х
        return c >= 0x40 && c <= 0xFC && c != 0x7F;
    }

    static int shiftJIStoJIS(int hi, int lo) { // եJISJIS
        if (hi <= 0x9F) {
            if (lo < 0x9F)  hi = (hi << 1) - 0xE1;
            else            hi = (hi << 1) - 0xE0;
        } else {
            if (lo < 0x9F)  hi = (hi << 1) - 0x161;
            else            hi = (hi << 1) - 0x160;
        }
        if      (lo < 0x7F) lo -= 0x1F;
        else if (lo < 0x9F) lo -= 0x20;
        else                lo -= 0x7E;

        return (hi << 8)| lo;
    }

    public static void main(String[] args) throws IOException {
        int c;

        while ((c = System.in.read()) != -1) {  // 1ХȤɤ߹
            if (isKanji(c)) {
                int d = System.in.read();
                if (isKanji2(d)) {
                    int e = shiftJIStoJIS(c, d);  // c : ̡d : ̥Х
                    System.out.write((e >> 8)| 0x80);  // EUC Ѵ1ХȤĽ񤭽Ф
                    System.out.write((e & 0xFF)| 0x80);
                } else {
                    System.out.write(c);
                    if (d != -1) System.out.write(d);
                }
            } else if (c == '\r');  // ⤷ʤ
            else System.out.write(c);
        }
    }
}
