/*
* BDCbrt.java -- ¿Ĺ¿Ω
* @version $Revision: 1.10 $, $Date: 2003/05/12 10:24:55 $
* BDTools.java ȤäƤ롣
*/

import java.io.*;
import java.math.*;

/**
*¿Ĺټ¿ΩޤϤεտޤ
*/
public class BDCbrt {
    public static int itr;  // ȿݻƤ롣
    public static final int ITR_MAX = 20;  // 15 * 2^20 ޤǡ
    public static final int DOUBLE_PREC =15; // double ͭ
    /**
    *Ωεտ<code>1/<i>x</i><sup>1/3</sup></code>ޤ
    *@param x <code>BigDecimal <i>x</i></code> Ϳޤ
    *@param precision ٤Ϳޤ
    *@return <code>1/<i>x</i><sup>1/3</sup></code>֤ޤ
    *Τޤ10ʤǽϤ礭ʷˤʤޤξ {@link BDTools#roundOff}
    *ȤäƤͭ2ʤǸѤäƤ뤿Ǥ
    * @see BDTools
    */
    public static BigDecimal recCubeRoot(BigDecimal x, int precision) {
        final BigDecimal THREE = new BigDecimal(3.0);
        // 0.01 < |x| < 10.0 ɸಽ롣
        int shift = BDTools.getExp10(x) / 3;
        x = x.movePointLeft(3 * shift);
        /* x 礭Ȳ̤0ͤ졤 appX = x.doubleValue(); ʤɤ
          ֤뤿ڤΤƤ롣
          x.movePointLeft() Ƚդˤ appX = NaN 顼ˤʤ롣
        */
        x = BDTools.roundOff(x, precision);
        double appX = x.doubleValue(); 
        if (appX < 0) x = x.negate();   // x = -x

        BigDecimal y = new BigDecimal(Math.pow(Math.abs(appX), -1/3.0)); // x = 0 ʤХ顼
        y = BDTools.roundOff(y, DOUBLE_PREC);  // ߤ
        BigDecimal dy;
        itr = 0;
        dy = x.subtract(new BigDecimal(Math.abs(appX)));  // ͤȤκ
        // x = 2.00000....00000123456 Τ褦 dy = O(10^(-p)) ˾ ef = 2 * p ˤȤ롣
        int ef = 2 * Math.max(DOUBLE_PREC, Math.abs(BDTools.getExp10(dy)));  // ٤ν, dy = 0 ξθ

        do {
            if (ef > precision) ef = precision;
            dy = BDMult.bdMult(y, y, ef);     // dy = y*y
            dy = BDMult.bdMult(y, dy, ef);    // dy = y^3
            dy = BDMult.bdMult(x, dy, ef);    // dy = x * y^3
            dy = BDTools.ONE.subtract(dy);    // dy = 1 - x * y^3
            dy = BDMult.bdMult(y, dy, ef);    // dy = y*(1 - x * y^3)
            dy = dy.divide(THREE, ef, BigDecimal.ROUND_HALF_EVEN); // dy /= 3;
            y = y.add(dy);   ef *= 2;   itr++;
        } while ( (dy.unscaledValue().bitLength() > 8 && itr < ITR_MAX) || ef < precision); // dy != 0 (dy.signum() != 0) Ǥϥᡣ

        if (itr == ITR_MAX) {
            System.err.println("\"recCubeRoot\" Ǽ«ޤ");
            System.exit(-1);
        }
        if (appX < 0)   y = y.negate();
        if (shift != 0) y = y.movePointLeft(shift);
        return y;
    }
    /**
    *<i>x</i> Ω<i>x</i><sup>1/3</sup> ޤ
    *@param x <code>BigDecimal <i>x</i></code> Ϳޤ
    *@param precision ٤Ϳޤ
    *@return <i>x</i><sup>1/3</sup> ֤ޤ
    */
    // x^(1/3) = x * /(x*x)^(1/3) 
    public static BigDecimal bdCubeRoot(BigDecimal x, int precision) {
        BigDecimal y = BDMult.bdMult(x, x, precision);   // y = x * x

        y = recCubeRoot(y, precision);
        return BDMult.bdMult(x, y, precision);
    }
    /**
    *ƥѡcbrt(2) = 2^(1/3) ϤǷ׻ޤ
    */
    static void getCbrt2(int precision) {
        BigDecimal TWO = new BigDecimal(2.0), cbrt2, d;

        BDTools.precision = precision;
        System.out.println("cbrt(2)  " + precision + " ׻");
        long start = System.currentTimeMillis();
        cbrt2 = bdCubeRoot(TWO, precision);
        long time = System.currentTimeMillis() - start;

        System.out.println("2^(1/3) =");
        BDTools.print(cbrt2, 10);
        System.out.print("ȿ = " + itr + " ׻ " + time + " (ms)");
        System.out.println("  Ϸ = " + BDTools.decNumber);

        d = TWO.subtract(BDPower.power(cbrt2, 3, precision));
        System.out.println("2 - {2^(1/3)}^3 γ = " + BDTools.toDoubleString(d));
    }
    public static void main(String[] args) throws IOException {
        System.out.print("1 / {2^(1/3)}  2^(1/3) ޤ\n(>32) ? = ");
        BufferedReader in = new
            BufferedReader(new InputStreamReader(System.in));
        int n = Integer.parseInt(in.readLine());
        if (n > 32) getCbrt2(n);
    }
}
