/*
* BDSqrt.java
* @version $Revision: 1.10 $, $Date: 2003/05/12 10:24:55 $
* BDTools.java  BDMult.java ȤäƤ롣
*/

import java.io.*;
import java.math.*;

/**
*¿Ĺټ¿ʿޤϤεտޤ<br>
*@see BDMult
*@see BDTools
*/

public class BDSqrt {
    public static int itr;
    public static final int ITR_MAX = 20;  // 15 * 2^20 ޤǡ
    public static final int DOUBLE_PREC = 15; // double ͭ
    /**
    *¿Ĺټ¿ʿεտ <code>1/sqrt(<i>x</i>)</code> ޤ<br>
    *ͤ10ʤǤηprecisionĹޤޤǤ{@link BDMult}ˡ
    *ڤΤƤˤ <code>BDTools.roundOff(r, precision);</code>
    * Ѥޤ뤤ϡ{@link BDTools#precision} ˽Ϸꤷ
    *BDToolsνϴؿƤӽФмưŪڤΤƤޤ
    *@param x <code>BigDecimal <i>x</i></code> Ϳޤ
    *@param precision 10ʤǤ٤Ϳޤ
    *@return <code>1/sqrt(<i>x</i>)</code> ֤ޤ
    */
    public static BigDecimal recSqrt(BigDecimal x, int precision) {
        final BigDecimal TWO = new BigDecimal(2.0);
        // 1 <= x < 100 ɸಽ롣
        int shift = BDTools.getExp10(x) / 2;
        x = x.movePointLeft(2 * shift);
        /* x 礭Ȳ̤0ͤ졤 appX = x.doubleValue(); ʤɤ
          ֤뤿ڤΤƤ롣*/
        x = BDTools.roundOff(x, precision);
        double appX  = x.doubleValue();  // double ζ
        BigDecimal y = new BigDecimal(1.0 / Math.sqrt(appX)), dy; // x <= 0 ΤȤ顼
        y = BDTools.roundOff(y, DOUBLE_PREC);  // ߤ
        itr = 0;
        dy = x.subtract(new BigDecimal(appX));  // ͤȤκ
        // x = 2.00000....00000123456 Τ褦 dy = O(10^(-p)) ˾ ef = 2 * p ˤȤ롣
        int ef = 2 * Math.max(DOUBLE_PREC, Math.abs(BDTools.getExp10(dy)));  // ٤ν, dy = 0 ξθ

        do {
            if (ef > precision) ef = precision;
            // dy = y*(1-x*y^2)
            dy = BDMult.bdMult(y, y, ef);     // dy = y*y
            dy = BDMult.bdMult(x, dy, ef);    // dy *= x
            dy = BDTools.ONE.subtract(dy);    // dy = 1 - dy
            dy = BDMult.bdMult(y, dy, ef);    // dy *= y
         // dy /= 2 աdy *= 0.5 Ⱦ軻ˤٻǤʤ dy = 0 ˤʤʤ
         // ޤ dy η׻ͭ(48)䤵ʤȸǿưƼ«ʤ
            dy = dy.divide(TWO, ef, BigDecimal.ROUND_HALF_EVEN);
            y = y.add(dy);   ef *= 2;  itr++;
        } while ( (dy.unscaledValue().bitLength() > 8 && itr < ITR_MAX) || ef < precision); // dy != 0 (dy.signum() != 0) Ǥϥᡣ

        if (itr == ITR_MAX) {
            System.err.println("\"recSqrt\" Ǽ«ޤ");
            System.exit(-1);
        }
        if (shift != 0) y = y.movePointLeft(shift);
        return y;
    }
    /**
    *¿Ĺټ¿ʿ <code>sqrt(<i>x</i>)</code> ޤ
    *@param x <code>BigDecimal <i>x</i></code> Ϳޤ
    *@param precision ٤Ϳޤ
    *@return <code>sqrt(<i>x</i>)</code> ֤ޤ
    */
    public static BigDecimal bdSqrt(BigDecimal x, int precision) {
        return BDMult.bdMult(recSqrt(x, precision), x, precision);
    }
    /**
    *ƥѡsqrt(2) ϤǷ׻ޤ
    */
    static void getSqrt2(int precision) {
        BigDecimal TWO = new BigDecimal(2.0), sqrt2, d;

        BDTools.precision = precision;
        System.out.println("sqrt(2)  " + precision + " ׻");
        long start = System.currentTimeMillis();
        sqrt2 = bdSqrt(TWO, precision);
        long time = System.currentTimeMillis() - start;

        System.out.println("sqrt(2) =");
        BDTools.print(sqrt2, 10);
        System.out.print("ȿ = " + itr + " ׻ " + time + " (ms)");
        System.out.println("  Ϸ = " + BDTools.decNumber);
        d = TWO.subtract(BDMult.bdMult(sqrt2, sqrt2, precision));
        System.out.println("2 - sqrt(2)^2 γ = " + BDTools.toDoubleString(d));
    }
    public static void main(String[] args) throws IOException {
        System.out.print("1 / sqrt(2)  sqrt(2) ޤ\n(>32) ? = ");
        BufferedReader in = new
            BufferedReader(new InputStreamReader(System.in));
        int n = Integer.parseInt(in.readLine());
        if (n > 32) getSqrt2(n);
    }
}
