/**
* BinarySplit2.java -- binary splitting method ݥ饹
* Ƶǡ
* @version $Revision: 1.1 $, $Date: 2003/03/20 02:30:36 $
*/
import java.math.*;     // BigInteger  BigDecimal 饹Ȥ

/**
* Ƶ binary splitting ˡݥ饹(abstract class)Ǥ
* @see BDMult
* @see BinarySplit1
* @see BinarySplitPi2
*/

public abstract class BinarySplit2 {
    private final int A = 0, B = 1, C = 2;  // enum{} ѡ
    private int L, N;
    BigDecimal X[], result;
    /**
    * 10 ʤǤ١ͭˤ֤ޤ
    */
    public int N()    { return N; }
    /**
    * L ֤ͤޤʸȡ
    */
    public int upTo() { return L; }
    /**
    * 桼 Xyz(int nint f) { super(n, f); } Τ褦ʥ󥹥ȥ饯
    * ɬפޤ
    * @see BinarySplitPi2
    * @param upto ιꤷޤ
    * @param N ͭꤷޤ
    */
    public BinarySplit2(int upto, int N) {
        L = upto;   this.N = N;
        X = new BigDecimal[3];
    }
    /**
    * A[k] ֤ݥ᥽åɤǤ<code><br></code>
    * ֥饹ǥС饤ɤɬפޤ
    */
    public abstract BigDecimal bsA(int k);
    /**
    * B[k] ֤ݥ᥽åɤǤ<code><br></code>
    * ֥饹ǥС饤ɤɬפޤ
    */
    public abstract BigDecimal bsB(int k);
    /**
    * C[k] ֤ݥ᥽åɤǤ<code><br></code>
    * ֥饹ǥС饤ɤɬפޤ
    */
    public abstract BigDecimal bsC(int k);

    /**
    * Ԥޤ
    */
    public void putTogether() { // 
        recursive(0, L, X);
    }

    private void recursive(int n0, int n1, BigDecimal[] Q) {
        if (n1 - n0 == 1) {
            Q[A] = bsA(n0); Q[B] = bsB(n0); Q[C] = bsC(n0);
            return;
        }
        BigDecimal[] left  = new BigDecimal[3];
        BigDecimal[] right = new BigDecimal[3];
        int midN = (n0 + n1) / 2;

        recursive(n0, midN, left);  // ƵƤӽФ¦
        recursive(midN, n1, right); // ¦

        BigDecimal p = BDMult.bdMult(left[A], right[C], N);

        Q[A] = p.add(BDMult.bdMult(left[B], right[A], N));// A(2k) * C(2k+1) + B(2k) * A(2k+1)
        Q[B] = BDMult.bdMult(left[B], right[B], N);       // B(2k) * B(2k+1)
        Q[C] = BDMult.bdMult(left[C], right[C], N);       // C(2k) * C(2k+1)
    }
    /**
    * ¤ BigDecimal ֤ޤ
    * @param inv C[0]/A[0]ˤ true A[0]/C[0]ξ false Ϳޤ
    */
    public BigDecimal getValue(boolean inv) {
        if (inv) result = X[C].divide(X[A], N, BigDecimal.ROUND_HALF_EVEN); // C[0]/A[0]
        else     result = X[A].divide(X[C], N, BigDecimal.ROUND_HALF_EVEN); // A[0]/C[0]
        return result;
    }
}
