/**
 * BitInputStream.java -- ӥåϥȥ꡼
 *
 * @version $Revision: 1.7 $, $Date: 2003/03/22 02:31:14 $
 */

import java.io.*;
/**
* HuffmanˡʤɤǻȤӥåϥ롼Ǥ
* @see BitOutputStream
* @see Huffman
* @see Slide
* @see Squeeze
*/
public class BitInputStream extends FilterInputStream {
    public static final int MAX_BITS = 31;  // ɤ߹߲ǽʺӥåȿ
    protected int getCount = 0; // ӥåϥ
    protected int bitBuf = 0;   // ӥåϥХåե
    /**
    * 󥹥ȥ饯
    * @param in ϥȥ꡼
    */
    public BitInputStream(InputStream in) {  super(in);  }
    /**
     * x α¦ n ӥåȤ֤
     */
    private static int rightBits(int n, int x) {
         return x & ((1 << n) - 1);
    }
    /**
    * 1ӥåȤɤ߹
    */
    public boolean getBit() throws IOException {
        if (--getCount >= 0) return ((bitBuf >>> getCount) & 1) == 1;
        getCount = 7;  bitBuf = in.read();
        return ((bitBuf >>> 7) & 1) == 1;
    }
    /**
    * nӥåȤɤ߹
    */
    public int getBits(int n) throws IOException {
        int x = 0;
        while (n > getCount) {
            n -= getCount;
            x |= rightBits(getCount, bitBuf) << n;
            bitBuf = in.read();  getCount = 8;
        }
        getCount -= n;
        return x | rightBits(n, bitBuf >>> getCount);
    }
}
