/**
* SBoyerMoo.java -- Boyer--Mooreˡ
* @version $Revision: 1.1 $, $Date: 2003/03/20 03:05:51 $
*/
/* άBoyer-Mooreˡ(String + charAt(i) )*/

import java.io.*;
/**
*άBoyer-Mooreˡˤʸȹ祢르ꥺΥץǤ
*@see KMP
*@see StringMatch
*/

public class BoyerMoore {
    static final int TABLE_SIZE = 255;
    /**
    *text 椫 pattern Τ֤õޤ
    *@param text ƥʸ
    *@param pattern ȹʸ
    *@return pattern Τ֡Ƭ 0
    *pattern Ĺ丫Ĥʤ -1 
    *pattern Ĺ 0 ξ 0 ֤ޤ
    */
    public static int position(String text, String pattern) {
        int[] skip = new int[TABLE_SIZE + 1];
        int len = pattern.length(); /* ʸĹ */

        if (len == 0) return -1;        /* 顼: Ĺ0 */
        char tail = pattern.charAt(len - 1);        /* Ǹʸ */
        if (len == 1) {                 /* Ĺ1ʤñ! */
            for (int i = 0; i < text.length(); i++)
                if (text.charAt(i) == tail) return i;
        } else {                       /* Ĺ2ʾʤɽäơ */
            int i;
            for (i = 0; i <= TABLE_SIZE; i++) skip[i] = len;
            for (i = 0; i < len - 1; i++)
                skip[pattern.charAt(i)] = len - 1 - i;
            /* i = len - 1; */          /* 褤ȹ */
            while (i < text.length()) {
                char c = text.charAt(i);
        /* ǥ󥹥ȥ졼 */
                System.out.print(": " + text);
                System.out.print("\n: ");
                for (int j = i + 1 - len; j > 0; j--) System.out.print(" ");
                System.out.println(pattern);
        /**************************/
                if (c == tail) {
                    int j = len - 1, k = i;
                    while (pattern.charAt(--j) == text.charAt(--k))
                        if (j == 0) return k;  /* Ĥä */
                }
                i += skip[c];
            }
        }
        return -1;  /* Ĥʤä */
    }

    /*
    * len = 0 : ƥʸϡĹ¤ʤ)
    * len > 0 : ȹʸϡĹ len ʲ
    */
    static String readInString(String s, int len) throws IOException {
        BufferedReader in =
            new BufferedReader(new InputStreamReader(System.in));

        if (len == 0) {
            String t = in.readLine();
            if (t.length() == 0) return s; // t 
            return t;
        }

        String t = in.readLine();
        if (t.length() > len) throw new Error("ȹʸĹޤ");
        return t;
    }
    /**
    * <code>text = "supercalifragilisticexpialidocious"</code> ξ
    *ץǤ<br>
    *<strong>&quot;ƥʸ&quot;</strong><strong>&quot;ȹʸ&quot;</strong>
    *ʹƤޤϤƤ<br>
    *в᤬ɽޤ
    */

    public static void main(String[] args) throws IOException {
        String text = "supercalifragilisticexpialidocious";
        String pattern = "";

        for ( ; ; ) {
            System.out.print("ƥʸ (Enter: " + text + ")\n  ? ");
            text = readInString(text, 0);
            System.out.print("ȹʸ (Enter: λ)\n  ? ");
            pattern = readInString(pattern, text.length());
            if (pattern.length() == 0) break;
            int p = position(text, pattern);
            if (p >= 0) System.out.print(" = " + p + "\n\n");
            else        System.out.print("Ĥޤ.\n\n");
        }
    }
}
