/**
 * Contain.java -- ֤޴ط
 *
 * @version $Revision: 1.6 $, $Date: 2003/03/23 15:32:32 $
 */

public class Contain {
    /** ֤ɽ饹 */
    public static class Interval implements Comparable {
        int left, right;
        public Interval(int left, int right) {
            this.left = left;   this.right = right;
        }
        public int compareTo(Object object) {  // Ӵؿ
            Interval x = (Interval)object;
            if (left  != x.left)  return left  - x.left;
            if (right != x.right) return right - x.right;
            /*
              // double ǤФȤ
              if (left  > x.left)  return  1;
              if (left  < x.left)  return -1;
              if (right > x.right) return  1;
              if (right < x.right) return -1;
            */
            return 0;
        }
        public String toString() {
            return "(" + left + ", " + right + ")";
        }
    }

    public static void markContained(Interval[] a, boolean[] contained) {
        java.util.Arrays.sort(a); // ɸ饤֥Υޡ $O(n \log n)$
        int maxRight = a[0].right;
        contained[0] = false;

        for (int i = 1; i < a.length; i++) {
            if (a[i].right <= maxRight) contained[i] = true;
            else {
                maxRight = a[i].right;  contained[i] = false;
            }
        }
    }

    /**
     * ȤäʣĤζ֤ꡤ޴طɽޤ<br>
     * ¾ζ֤˴ޤޤƤΤˤ * դޤ
     */
    public static void main(String[] args) {
        final int N = 20;
        Contain.Interval[] a = new Contain.Interval[N];  // a[i]  null
        boolean[] contained = new boolean[N];

        int i = 0;
        while (i < N) {
            int x = (int)(Math.random() * 100);
            int y = (int)(Math.random() * 100);
            if (x < y) { a[i] = new Contain.Interval(x, y);  i++;  }
        }

        Contain.markContained(a, contained);
        for (i = 0; i < N; i++)
            System.out.println(a[i] + (contained[i] ? " *" : ""));
    }
}
