/**
 *  Fukumen.java -- ʤ̻
 *
 *  @version $Revision: 1.8 $, $Date: 2003/03/29 11:34:48 $
 */

import java.io.*;
import java.util.HashMap;

public class Fukumen {
    static class Letter {
        int current, lower, upper;
        Letter(char c) {  
            if (!Character.isDigit(c)) current = -1;  // ʸͤϲѡ
            else current = Character.digit(c, 10);    // ͤϸ
            lower = 0;  upper = 10;
        }
    }
    static final Letter ZERO = new Letter('0');
    static int row, col, solution;
    static Letter[][] words;
    static boolean fixed[] = new boolean[10];

    private static void found() { // ɽ
        System.out.println("\n " + (++solution));
        for (int i = 0; i < row; i++) {
            if (i == row - 1) {
                for (int j = col; j >= 0; j--) System.out.print("-");
                System.out.println();
            }
            if (i == row - 2) System.out.print("+");
            else              System.out.print(" ");
            for (int j = col - 1; j >= 0; j--)
                if (words[i][j] == null) System.out.print(" ");
                else System.out.print(words[i][j].current);
            System.out.println();
        }
    }

    private static void search(int sum, int i, int j) {
        Letter a = words[i][j];  if (a == null) a = ZERO;
        if (i < row - 1) {
            if (a.current < 0) {  // ޤäƤʤʤ
                for (int d = a.lower; d < a.upper; d++)
                    if (!fixed[d]) {
                        a.current = d;  fixed[d] = true;
                        search(sum + d, i + 1, j);  fixed[d] = false;
                    }
                a.current = -1;
            } else search(sum + a.current, i + 1, j);
        } else {  // ǲʤι
            int d = sum % 10,  carry = sum / 10;
            if (a.current == d) {
                if (j + 1 < col) search(carry, 0, j + 1);
                else if (carry == 0) found();
            } else if (a.current < 0 && !fixed[d] && d >= a.lower) {
                a.current = d;  fixed[d] = true;
                if (j + 1 < col) search(carry, 0, j + 1);
                else if (carry == 0) found();
                a.current = -1;  fixed[d] = false;
            }
        }
    }

    /**
     * ꤷĿ<b>Կ</b>ˤʸ
     * enter ǶڤäϤȡǽʲ򤹤٤ƽϤޤ
     * <blockquote><pre>
     * <b></b>ʲʬϤ
     * Կ? <code><u>3</u>
     * 1: <u>send</u>
     * 2: <u>more</u>
     * 3: <u>money</u><br></code>
     * 
     *  1<code>
     *   9567
     * + 1085
     * ------
     *  10652
     * </code></pre></blockquote>
     */
    public static void main(String[] args) throws IOException {
        BufferedReader in = new
            BufferedReader(new InputStreamReader(System.in));
        System.out.print("Կ ");
        row = Integer.parseInt(in.readLine());
        String[] buffers = new String[row];
        for (int i = 0; i < row; i++) {
            System.out.print((i + 1) + ": ");
            buffers[i] = in.readLine();
            if (col < buffers[i].length()) col = buffers[i].length();
        }

        words = new Letter[row][col];
        HashMap letters = new HashMap();  // Character -> Letter бɽ
        for (int i = 0; i < row; i++) {
            int k = buffers[i].length();
            for (int j = 0; j < k; j++) {
                char c = buffers[i].charAt(k - 1 - j);
                Letter a = (Letter)letters.get(new Character(c));
                if (a == null) {  //  Letter ɲ
                    a = new Letter(c);  letters.put(new Character(c), a);
                }
                words[i][j] = a;
                if (j == k - 1) a.lower = 1;  // üʸ1ʾ
            }
        }
        for (int i = 0; i < 10; i++) fixed[i] = false;
        solution = 0;  search(0, 0, 0);
        if (solution == 0) System.out.println("Ϥޤ");
    }
}
