/*
* Newton2Test.java -- Newtonˡ(Newton2)λ
* @version $Revision: 1.3 $, $Date: 2003/04/05 15:10:00 $
*/
/**
*Newtonˡ(Newton2)λǤ
*/
import java.io.*;


public class Newton2Test {
    static class Function implements Newton2.Function {
        public double of(double x) { // ᤿ؿ
            return x * (x * x - 1);
        }
    }
    /**
    * ͤϤ <code><i>x</i><sup>3</sup> - x = 0</code> βɽޤ
    */
    public static void main(String[] args) throws IOException {
        BufferedReader input =
            new BufferedReader(new InputStreamReader(System.in));

        System.out.println("x^3 - x = 0 򤭤ޤ.");
        System.out.print(" = ");
        double x0 = Double.parseDouble(input.readLine());

        Function f = new Function();
        double x = Newton2.solve(f, x0);

        System.out.println("x = " + x);
        System.out.println("f(x) = " + f.of(x));
    }
}
