/**
 *  ȹ礻
 *
 *  @version $Revision: 1.3 $, $Date: 2003/04/28 23:23:17 $
 */

public class NextCombination {
    final int n, k, a[];

    public NextCombination(int n, int k) {
        this.n = n;
        this.k = k;
        a = new int[k + 1];
        for (int i = 1; i <= k; i++) a[i] = i;
    }

    public boolean next() {  // 񼰽Ǽȹ礻
        a[0] = n;  // ֿ
        int i = k;
        while (a[i] == n - k + i) i--;
        if (i == 0) return false;  // λ
        a[i]++;
        while (++i <= k) a[i] = a[i - 1] + 1;
        return true;  // ̤λ
    }

    public String toString() {
        String s = "";
        for (int i = 1; i <= k; i++) s += "  " + a[i];
        return s;
    }

    public static void main(String[] args) {
        NextCombination c = new NextCombination(6, 4);
        int count = 0;
        do {
            System.out.println((++count) + ":" + c);
        } while (c.next());
    }
}
