/**
 *  
 *
 *  @version $Revision: 1.3 $, $Date: 2003/04/28 23:23:18 $
 */


/** ̤ */
public class PermutationGenerator {
    static int n, a[], count;

    public static void init(int num) {  // ̤ν
        n = num;  a = new int[n];  count = 0;
    }

    public static void show() {
        count++;  System.out.print(count + ": ");
        for (int i = 0; i < n; i++) System.out.print(" " + a[i]);
        System.out.println();
    }

    /** ˡΥƥ */

    public static void main(String[] args) {
        System.out.println("ˡ 1");  PermutationGenerator1.generate(4);
        System.out.println("ˡ 2");  PermutationGenerator2.generate(4);
        System.out.println("ˡ 3");  PermutationGenerator3.generate(4);
        System.out.println("ˡ 4");  PermutationGenerator4.generate(4);
    }
}


/** ˡ 1 */
class PermutationGenerator1 extends PermutationGenerator {
    static boolean used[];

    public static void generate(int n) {
        init(n);  // ̤ν
        used = new boolean[n + 1];
        for (int k = 1; k <= n; k++) used[k] = false;  // ̤Ѥɸ
        put(0);
    }

    static void put(int pos) {
        if (pos == n) {  show();  return;  }
        for (int k = 1; k <= n; k++)
            if (!used[k]) {
                used[k] = true;  a[pos] = k;  put(pos + 1);
                used[k] = false;
            }
    }
}



/** ˡ 2 */
class PermutationGenerator2 extends PermutationGenerator {
    public static void generate(int n) {
        init(n);  // ̤ν
        for (int pos = 0; pos < n; pos++) a[pos] = 0;  // ̤Ѥɸ
        put(1);
    }

    static void put(int k) {
        if (k == n + 1) {  show();  return;  }
        for (int pos = 0; pos < n; pos++)
            if (a[pos] == 0) {
                a[pos] = k;  put(k + 1);
                a[pos] = 0;
            }
    }
}


/** ˡ 3 */
class PermutationGenerator3 extends PermutationGenerator {
    public static void generate(int n) {
        init(n);  // ̤ν
        for (int i = 0; i < n; i++) a[i] = i + 1;
        perm(n - 1);
    }

    static void perm(int pos) {
        if (pos == 0) {  show();  return;  }
        for (int i = pos; i >= 0; i--) {
            int swap = a[pos];  a[pos] = a[i];  a[i] = swap;
            perm(pos - 1);
            swap = a[pos];  a[pos] = a[i];  a[i] = swap;
        }
    }
}


/** ˡ 4 */
class PermutationGenerator4 extends PermutationGenerator {
    public static void generate(int n) {
        init(n);  // ̤ν
        int c[] = new int [n + 1];
        for (int i = 0; i < n; i++) a[i] = i + 1;
        for (int i = 1; i <= n; i++) c[i] = i;  // c[n]0 ֿ

        for (int k = 1; k < n; ) {
            int i;
            if ((k % 2) == 0) i = 0;  else i = c[k];
            int swap = a[k];  a[k] = a[i];  a[i] = swap;
            show();
            for (k = 1; c[k] == 0; k++) c[k] = k;
            c[k]--;
        }
    }
}
