/**
 *  ִ
 *
 *  @version $Revision: 1.3 $, $Date: 2003/04/28 23:23:18 $
 */

public class PermutationSign {
    static int sign(int n, int v[]) {
        int[] w = new int[n + 1];
        for (int i = 1; i <= n; i++) w[v[i]] = i;

        int p = 1;
        for (int i = 1; i <= n - 1; i++) {
            int j = v[i];
            if (j != i) {
                v[w[i]] = j;  w[j] = w[i];  p = -p;
            }
        }
        return p;
    }

    static void test1(int n) {
        System.out.println("񼰽:");
        NextPermutation p = new NextPermutation(n);
        int[] v = new int[n + 1];

        int count = 0;
        do {
            System.out.print((++count) + ":" + p);
            for (int i = 1; i <= n; i++) v[i] = p.a[i];
            System.out.println((sign(n, v) == 1) ? "  ִ" : "  ִ");
        } while (p.next());
    }

    static void test2(int n) {
        System.out.println("ߴˤ:");
        int[] a = new int[n + 1], c = new int[n + 2], v = new int[n + 1];
        for (int i = 1; i <= n; i++) a[i] = c[i] = i;
        c[n + 1] = 0;  // c[n + 1]1 ֿ

        int count = 0;
        for (int k = 2; k <= n; c[k]--) {
            int i;
            if ((k % 2) == 1) i = 1;  else i = c[k];
            int swap = a[k];  a[k] = a[i];  a[i] = swap;
            System.out.print((++count) + ":");
            for (i = 1; i <= n; i++) System.out.print(" "+ (v[i] = a[i]));
            System.out.println((sign(n, v) == 1) ? "  ִ" : "  ִ");
            for (k = 2; c[k] == 1; k++) c[k] = k;
        }
    }

    public static void main(String[] args) {
        test1(4);
        test2(4);
    }
}
