/**
* SKanji.java -- EUCʤɤ򥷥եJISɤѴ
*  @version $Revision: 1.1 $, $Date: 2003/04/04 11:18:23 $
*
* java SKanji < infile > outfile
*
* Τ褦˻Ȥ
*/

import java.io.*;

/**
* EUC ʤɤޤե򥷥ե JIS ɤΤΤѴѴޤ<br>
* UNIX  '\n'  MSϤ &quot;\r\n&quot; ΥڥѴޤ<br>
* ˡ<code>java SKanji &lt; infile &gt; outfile</code>
* @see EUCtoSJIS
*/

public class SKanji {
    static int toShiftJIS(int hi, int lo) {  // JIS򥷥եJIS
        if ((hi & 1) != 0) {
            if (lo < 0x60)  lo += 0x1F;
            else            lo += 0x20;
        } else              lo += 0x7E;
        if (hi < 0x5F)      hi = (hi + 0xE1) >> 1;
        else                hi = (hi + 0x161) >> 1;

        return (hi << 8)| lo;
    }

    static final int ESC = 0x1B;  // ʸ

    public static void main(String[] args) throws IOException {
        int c;
        boolean jisKanji = false;

        while ((c = System.in.read()) != -1) {  // 1ХȤɤ߹
            if (c == ESC) {
                if ((c = System.in.read()) == '$') {
                    if ((c = System.in.read()) == '@' || c == 'B') {
                        jisKanji = true;  // JIS
                    } else {
                        System.out.write(ESC);  System.out.write('$');  // 1ХȤĽ񤭽Ф
                        if (c != -1) System.out.write(c);
                    }
                } else if (c == '(') {
                    if ((c = System.in.read()) == 'H' || c == 'J') {
                        jisKanji = false;  // JISλ
                    } else {
                        System.out.write(ESC);  System.out.write('(');
                        if (c != -1) System.out.write(c);
                    }
                } else if (c == 'K') {
                    jisKanji = true;   // NECJIS
                } else if (c == 'H') {
                    jisKanji = false;  // NECJISλ
                } else {
                    System.out.write(ESC);
                    if (c != -1) System.out.write(c);
                }
            } else if (jisKanji && c >= 0x21 && c <= 0x7E) {
                int d = System.in.read();
                if (d >= 0x21 && d <= 0x7E) {  // JIS
                    int e = toShiftJIS(c, d);
                    c = e >> 8;  d = e & 0xFF;
                }
                System.out.write(c);
                if (d != -1) System.out.write(d);
            } else if (c >= 0xA1 && c <= 0xFE) {
                int d = System.in.read();
                if (d >= 0xA1 && d <= 0xFE) {  // EUC
                    int e = toShiftJIS(c & 0x7F, d & 0x7F);
                    c = e >> 8;  d = e & 0xFF;
                }
                System.out.write(c);
                if (d != -1) System.out.write(d);
            } else {
                if (c == '\n') System.out.write('\r');
                System.out.write(c);
            }
        }
    }
}
