/**
 *  Ū
 *  : java Warshall < Warshall.data
 *
 *  @version $Revision: 1.3 $, $Date: 2003/04/28 23:23:20 $
 */

import java.io.*;
import java.util.*;

public class Warshall {
    static int n;  // ο
    static int[][] adjacent;  // ܹ

    public static void readGraph() throws IOException { // 
        BufferedReader input =
            new BufferedReader(new InputStreamReader(System.in));

        StringTokenizer t = new StringTokenizer(input.readLine());
        n = Integer.parseInt(t.nextToken());
        adjacent = new int[n + 1][n + 1];
        for (int i = 1; i <= n; i++) {
            for (int j = 1; j <= n; j++) adjacent[i][j] = 0;
            adjacent[i][i] = 1;
        }

        String s;
        while ((s = input.readLine()) != null) {
            t = new StringTokenizer(s);
            int i = Integer.parseInt(t.nextToken());
            int j = Integer.parseInt(t.nextToken());
            adjacent[i][j] = 1;
        }

        System.out.println("ܹ:");
        for (int i = 1; i <= n; i++) {
            for (int j = 1; j <= n; j++)
                System.out.print(" " + adjacent[i][j]);
            System.out.println();
        }
    }

    public static void main(String[] args) throws IOException {
        readGraph();  // ܹɤ
        for (int k = 1; k <= n; k++)
            for (int i = 1; i <= n; i++)
                if (adjacent[i][k] != 0)
                    for (int j = 1; j <= n; j++)
                        if (adjacent[k][j] != 0) adjacent[i][j] = 1;
        System.out.println("Ū:");
        for (int i = 1; i <= n; i++) {
            for (int j = 1; j <= n; j++)
                System.out.print(" " + adjacent[i][j]);
            System.out.println();
        }
    }
}
